/*
*	New C++ File starts here.
*	This file should be named kalman_filtern.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "kalman_filtern.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : kalman_filterFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
int kalman_filterFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case KALMAN_FILTER_HALT_TYPE:
		((KALMAN_FILTER_HALT *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_INIT_TYPE:
		((KALMAN_FILTER_INIT *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_RUN_TYPE:
		((KALMAN_FILTER_RUN *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_COVARIANCE_TYPE:
		((KALMAN_FILTER_SET_COVARIANCE *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_NOISE_COVARIANCE_TYPE:
		((KALMAN_FILTER_SET_NOISE_COVARIANCE *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV_TYPE:
		((KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_STATE_TYPE:
		((KALMAN_FILTER_SET_STATE *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_SYS_MATRIX_A_TYPE:
		((KALMAN_FILTER_SET_SYS_MATRIX_A *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_SYS_MATRIX_B_TYPE:
		((KALMAN_FILTER_SET_SYS_MATRIX_B *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_SYS_MATRIX_C_TYPE:
		((KALMAN_FILTER_SET_SYS_MATRIX_C *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV_TYPE:
		((KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV *) buffer)->update(cms);
		break;
	case KALMAN_FILTER_STATUS_TYPE:
		((KALMAN_FILTER_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *kalman_filter_symbol_lookup(int type)
{
	switch(type)
	{
	case KALMAN_FILTER_HALT_TYPE:
		return "KALMAN_FILTER_HALT";
	case KALMAN_FILTER_INIT_TYPE:
		return "KALMAN_FILTER_INIT";
	case KALMAN_FILTER_RUN_TYPE:
		return "KALMAN_FILTER_RUN";
	case KALMAN_FILTER_SET_COVARIANCE_TYPE:
		return "KALMAN_FILTER_SET_COVARIANCE";
	case KALMAN_FILTER_SET_NOISE_COVARIANCE_TYPE:
		return "KALMAN_FILTER_SET_NOISE_COVARIANCE";
	case KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV_TYPE:
		return "KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV";
	case KALMAN_FILTER_SET_STATE_TYPE:
		return "KALMAN_FILTER_SET_STATE";
	case KALMAN_FILTER_SET_SYS_MATRIX_A_TYPE:
		return "KALMAN_FILTER_SET_SYS_MATRIX_A";
	case KALMAN_FILTER_SET_SYS_MATRIX_B_TYPE:
		return "KALMAN_FILTER_SET_SYS_MATRIX_B";
	case KALMAN_FILTER_SET_SYS_MATRIX_C_TYPE:
		return "KALMAN_FILTER_SET_SYS_MATRIX_C";
	case KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV_TYPE:
		return "KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV";
	case KALMAN_FILTER_STATUS_TYPE:
		return "KALMAN_FILTER_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for KALMAN_FILTER_SET_SYS_MATRIX_C
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_SYS_MATRIX_C::update(CMS *cms)
{
	cms->update(matrix_C_elements,2);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_SYS_MATRIX_B
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_SYS_MATRIX_B::update(CMS *cms)
{
	cms->update(matrix_B_elements,2);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_SYS_MATRIX_A
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_SYS_MATRIX_A::update(CMS *cms)
{
	cms->update(matrix_A_elements,4);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_STATUS::update(CMS *cms)
{
	cms->update(state_estimates,2);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_STATE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_STATE::update(CMS *cms)
{
	cms->update(state_to_set,2);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV::update(CMS *cms)
{
	cms->update(diag_value);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_COVARIANCE::update(CMS *cms)
{
	cms->update(diag_value);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_NOISE_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_NOISE_COVARIANCE::update(CMS *cms)
{
	cms->update(covariance_elements,2);

}


/*
*	NML/CMS Update function for KALMAN_FILTER_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_INIT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for KALMAN_FILTER_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_RUN::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
void KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV::update(CMS *cms)
{
	cms->update(diag_value);

}

/*
*	Constructor for KALMAN_FILTER_SET_SYS_MATRIX_C
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_SYS_MATRIX_C::KALMAN_FILTER_SET_SYS_MATRIX_C()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_SYS_MATRIX_C_TYPE,sizeof(KALMAN_FILTER_SET_SYS_MATRIX_C))
{

}

/*
*	Constructor for KALMAN_FILTER_SET_SYS_MATRIX_B
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_SYS_MATRIX_B::KALMAN_FILTER_SET_SYS_MATRIX_B()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_SYS_MATRIX_B_TYPE,sizeof(KALMAN_FILTER_SET_SYS_MATRIX_B))
{

}

/*
*	Constructor for KALMAN_FILTER_SET_SYS_MATRIX_A
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_SYS_MATRIX_A::KALMAN_FILTER_SET_SYS_MATRIX_A()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_SYS_MATRIX_A_TYPE,sizeof(KALMAN_FILTER_SET_SYS_MATRIX_A))
{

}

/*
*	Constructor for KALMAN_FILTER_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_STATUS::KALMAN_FILTER_STATUS()
	: RCS_STAT_MSG(KALMAN_FILTER_STATUS_TYPE,sizeof(KALMAN_FILTER_STATUS))
{
	/*
	* The array state_estimates should be initialized here.
	*/


}

/*
*	Constructor for KALMAN_FILTER_SET_STATE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_STATE::KALMAN_FILTER_SET_STATE()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_STATE_TYPE,sizeof(KALMAN_FILTER_SET_STATE))
{
	/*
	* The array state_to_set should be initialized here.
	*/


}

/*
*	Constructor for KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV::KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV_TYPE,sizeof(KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV))
{
	diag_value = (double) 0;

}

/*
*	Constructor for KALMAN_FILTER_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_HALT::KALMAN_FILTER_HALT()
	: RCS_CMD_MSG(KALMAN_FILTER_HALT_TYPE,sizeof(KALMAN_FILTER_HALT))
{

}

/*
*	Constructor for KALMAN_FILTER_SET_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_COVARIANCE::KALMAN_FILTER_SET_COVARIANCE()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_COVARIANCE_TYPE,sizeof(KALMAN_FILTER_SET_COVARIANCE))
{
	diag_value = (double) 0;

}

/*
*	Constructor for KALMAN_FILTER_SET_NOISE_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_NOISE_COVARIANCE::KALMAN_FILTER_SET_NOISE_COVARIANCE()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_NOISE_COVARIANCE_TYPE,sizeof(KALMAN_FILTER_SET_NOISE_COVARIANCE))
{

}

/*
*	Constructor for KALMAN_FILTER_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_INIT::KALMAN_FILTER_INIT()
	: RCS_CMD_MSG(KALMAN_FILTER_INIT_TYPE,sizeof(KALMAN_FILTER_INIT))
{

}

/*
*	Constructor for KALMAN_FILTER_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_RUN::KALMAN_FILTER_RUN()
	: RCS_CMD_MSG(KALMAN_FILTER_RUN_TYPE,sizeof(KALMAN_FILTER_RUN))
{

}

/*
*	Constructor for KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Dec 19 15:20:43 EST 2000
*/
KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV::KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV()
	: RCS_CMD_MSG(KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV_TYPE,sizeof(KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV))
{
	diag_value = (double) 0;

}

