/*
kalman_filter.cc

This C++ file defines member functions for the class KALMAN_FILTER_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Mon Dec 18 15:46:19 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "kalman_filter.hh" 	// KALMAN_FILTER_MODULE definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "kalman_filtern.hh" 	// NML Commands and Status definitions for kalman_filter
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
KALMAN_FILTER_MODULE::KALMAN_FILTER_MODULE(int _is_base_class)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
	if(!_is_base_class)
	{
		INITIALIZE_NML();
	}
	// Add additional code to initialize the module here.
        num_of_states = NUM_OF_STATES;
        num_of_inputs = NUM_OF_INPUTS;
        num_of_outputs = NUM_OF_OUTPUTS;
        k_fltr = new K_FLTR(num_of_states, num_of_inputs, num_of_outputs);
        if (k_fltr->k_fltr_err != K_FLTR_NO_ERROR)
          {
            logError("Error in creating KALMAN_FILTER_MODULE object!!!");
            status = RCS_ERROR; // let my supervisor know I have a problem.
          }

    if ((state_estimates = new double[num_of_states]) == NULL)
      {
	logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	status = RCS_ERROR; // let my supervisor know I have a problem.
      }

    if ((plant_outputs = new double[num_of_outputs]) == NULL)
      {
	logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	status = RCS_ERROR; // let my supervisor know I have a problem.
      }

    if ((plant_inputs = new double[num_of_inputs]) == NULL)
      {
	logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	status = RCS_ERROR; // let my supervisor know I have a problem.
      }

    if ((temp1 = new double*[num_of_outputs]) == NULL)
      {
	logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	status = RCS_ERROR; // let my supervisor know I have a problem.
      }
    for (int ii = 0; ii < num_of_outputs; ii++)
      {
	if ((temp1[ii] = new double[num_of_states]) == NULL)
	  {
	    logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	    status = RCS_ERROR; // let my supervisor know I have a problem.
	  }
      }
    
    if ((temp2 = new double*[num_of_states]) == NULL)
      {
	logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	status = RCS_ERROR; // let my supervisor know I have a problem.
      }

      for (int ii = 0; ii < num_of_states; ii++)
	{
	  if ((temp2[ii] = new double[num_of_states]) == NULL)
	    {
	      logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	      status = RCS_ERROR; // let my supervisor know I have a problem.
	    }
	}

      if ((temp3 = new double*[num_of_states]) == NULL)
	{
	  logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	  status = RCS_ERROR; // let my supervisor know I have a problem.
	}
      for (int ii = 0; ii < num_of_states; ii++)
	{
	  if ((temp3[ii] = new double[num_of_inputs]) == NULL)
	    {
	      logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	      status = RCS_ERROR; // let my supervisor know I have a problem.
	    }
	}
}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void KALMAN_FILTER_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "kalman_filter", "k_fltr_module.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(kalman_filterFormat, "kalman_filter_cmd", "kalman_filter", "k_fltr_module.nml"));
	kalman_filter_status = new KALMAN_FILTER_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(kalman_filterFormat, "kalman_filter_sts", "kalman_filter", "k_fltr_module.nml"), kalman_filter_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.
*/
void KALMAN_FILTER_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code
  // Read the current plant outputs
  for (int ii = 0; ii < num_of_outputs; ii++)
    {
      plant_outputs[ii] = 0;
    }

  // Read the current plant inputs
  for (int ii = 0; ii < num_of_inputs; ii++)
    {
      plant_inputs[ii] = 0;
    }
  
}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.
*/
void KALMAN_FILTER_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case KALMAN_FILTER_INIT_TYPE:
		INIT((KALMAN_FILTER_INIT *)commandInData);
		break;

	case KALMAN_FILTER_HALT_TYPE:
		HALT((KALMAN_FILTER_HALT *)commandInData);
		break;

	case KALMAN_FILTER_RUN_TYPE:
		RUN((KALMAN_FILTER_RUN *)commandInData);
		break;

	case KALMAN_FILTER_SET_COVARIANCE_TYPE:
		SET_COVARIANCE((KALMAN_FILTER_SET_COVARIANCE *)commandInData);
		break;

	case KALMAN_FILTER_SET_NOISE_COVARIANCE_TYPE:
		SET_NOISE_COVARIANCE((KALMAN_FILTER_SET_NOISE_COVARIANCE *)commandInData);
		break;

	case KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV_TYPE:
		SET_OUT_NOISE_AUTOCOV((KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV *)commandInData);
		break;

	case KALMAN_FILTER_SET_STATE_TYPE:
		SET_STATE((KALMAN_FILTER_SET_STATE *)commandInData);
		break;

	case KALMAN_FILTER_SET_SYS_MATRIX_A_TYPE:
		SET_SYS_MATRIX_A((KALMAN_FILTER_SET_SYS_MATRIX_A *)commandInData);
		break;

	case KALMAN_FILTER_SET_SYS_MATRIX_B_TYPE:
		SET_SYS_MATRIX_B((KALMAN_FILTER_SET_SYS_MATRIX_B *)commandInData);
		break;

	case KALMAN_FILTER_SET_SYS_MATRIX_C_TYPE:
		SET_SYS_MATRIX_C((KALMAN_FILTER_SET_SYS_MATRIX_C *)commandInData);
		break;

	case KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV_TYPE:
		SET_SYS_NOISE_AUTOCOV((KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.
*/
void KALMAN_FILTER_MODULE::POST_PROCESS()
{
	// Post-Processing Code
  // Report the current state estimates
  for (int ii = 0; ii < num_of_states; ii++)
    {
      kalman_filter_status->state_estimates[ii] = state_estimates[ii];
    }

}

// Command Functions

/*
INIT

Parameter(s):
KALMAN_FILTER_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void KALMAN_FILTER_MODULE::INIT(KALMAN_FILTER_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
KALMAN_FILTER_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void KALMAN_FILTER_MODULE::HALT(KALMAN_FILTER_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
RUN

Parameter(s):
KALMAN_FILTER_RUN *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::RUN(KALMAN_FILTER_RUN *cmd_in)
{
	// Put state table for KALMAN_FILTER_RUN here.
  // Put state table for RLS_ESTIMATE here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      k_fltr->filter(plant_outputs, plant_inputs, state_estimates);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_COVARIANCE

Parameter(s):
KALMAN_FILTER_SET_COVARIANCE *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_COVARIANCE(KALMAN_FILTER_SET_COVARIANCE *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_COVARIANCE here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the covariance matrix to diag_value*Identity
      k_fltr->set_cov_Sigma(cmd_in->diag_value);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_NOISE_COVARIANCE

Parameter(s):
KALMAN_FILTER_SET_NOISE_COVARIANCE *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_NOISE_COVARIANCE(KALMAN_FILTER_SET_NOISE_COVARIANCE *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_NOISE_COVARIANCE here.
  int ii, jj;

  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_outputs; ii++)
	{
 	  for (jj = 0; jj < num_of_states; jj++)
	    {
	      temp1[ii][jj] = cmd_in->covariance_elements[ii*num_of_states + jj];
	    }
	}

      // Set the noise covariance matrix to the specified value
      k_fltr->set_noise_cov(temp1);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_OUT_NOISE_AUTOCOV

Parameter(s):
KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_OUT_NOISE_AUTOCOV(KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the autocovariance matrix to diag_value*Identity
      k_fltr->set_out_noise_autocov(cmd_in->diag_value);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_STATE

Parameter(s):
KALMAN_FILTER_SET_STATE *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_STATE(KALMAN_FILTER_SET_STATE *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_STATE here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the autocovariance matrix to diag_value*Identity
      k_fltr->set_state(cmd_in->state_to_set);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_SYS_MATRIX_A

Parameter(s):
KALMAN_FILTER_SET_SYS_MATRIX_A *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_SYS_MATRIX_A(KALMAN_FILTER_SET_SYS_MATRIX_A *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_SYS_MATRIX_A here.
  int ii, jj;

  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_states; ii++)
	{
  	  for (jj = 0; jj < num_of_states; jj++)
	    {
	      temp2[ii][jj] = cmd_in->matrix_A_elements[ii*num_of_states + jj];
	    }
	}

      // Set the system matrix A to the specified value
      k_fltr->set_sys_matrix_A(temp2);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_SYS_MATRIX_B

Parameter(s):
KALMAN_FILTER_SET_SYS_MATRIX_B *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_SYS_MATRIX_B(KALMAN_FILTER_SET_SYS_MATRIX_B *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_SYS_MATRIX_B here.
  int ii, jj;

  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_states; ii++)
	{
  	  for (jj = 0; jj < num_of_inputs; jj++)
	    {
	      temp3[ii][jj] = cmd_in->matrix_B_elements[ii*num_of_inputs + jj];
	    }
	}

      // Set the system matrix B to the specified value
      k_fltr->set_sys_matrix_B(temp3);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_SYS_MATRIX_C

Parameter(s):
KALMAN_FILTER_SET_SYS_MATRIX_C *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_SYS_MATRIX_C(KALMAN_FILTER_SET_SYS_MATRIX_C *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_SYS_MATRIX_C here.
  int ii, jj;

  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_outputs; ii++)
	{
  	  for (jj = 0; jj < num_of_states; jj++)
	    {
	      temp1[ii][jj] = cmd_in->matrix_C_elements[ii*num_of_states + jj];
	    }
	}

      // Set the system matrix C to the specified value
      k_fltr->set_sys_matrix_C(temp1);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_SYS_NOISE_AUTOCOV

Parameter(s):
KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV *cmd_in -- NML Message sent from superior.

*/
void KALMAN_FILTER_MODULE::SET_SYS_NOISE_AUTOCOV(KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV *cmd_in)
{
	// Put state table for KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the autocovariance matrix to diag_value*Identity
      k_fltr->set_sys_noise_autocov(cmd_in->diag_value);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

