/*
kalman_filter.hh

This C++ header file defines the class KALMAN_FILTER_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Mon Dec 18 15:46:17 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef KALMAN_FILTER_HH
#define KALMAN_FILTER_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "k_fltr.hh"  // K_FLTR definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "kalman_filtern.hh" 	// NML Commands and Status definitions for kalman_filter
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class KALMAN_FILTER_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	KALMAN_FILTER_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(KALMAN_FILTER_INIT *);
	virtual void HALT(KALMAN_FILTER_HALT *);
	virtual void RUN(KALMAN_FILTER_RUN *);
	virtual void SET_COVARIANCE(KALMAN_FILTER_SET_COVARIANCE *);
	virtual void SET_NOISE_COVARIANCE(KALMAN_FILTER_SET_NOISE_COVARIANCE *);
	virtual void SET_OUT_NOISE_AUTOCOV(KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV *);
	virtual void SET_STATE(KALMAN_FILTER_SET_STATE *);
	virtual void SET_SYS_MATRIX_A(KALMAN_FILTER_SET_SYS_MATRIX_A *);
	virtual void SET_SYS_MATRIX_B(KALMAN_FILTER_SET_SYS_MATRIX_B *);
	virtual void SET_SYS_MATRIX_C(KALMAN_FILTER_SET_SYS_MATRIX_C *);
	virtual void SET_SYS_NOISE_AUTOCOV(KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV *);

	// Convenience Variables
	KALMAN_FILTER_STATUS *kalman_filter_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_of_states;
  int num_of_inputs;
  int num_of_outputs;
  K_FLTR *k_fltr;

  double *state_estimates;
  double *plant_outputs;
  double *plant_inputs;

  double **temp1;
  double **temp2;
  double **temp3;

};

#endif 	// KALMAN_FILTER_HH

