/*
	k_fltr_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Mon Dec 18 15:46:19 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "kalman_filtern.hh" 	// kalman_filterFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *kalman_filter_cmd = NULL;
static RCS_STAT_CHANNEL *kalman_filter_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// kalman_filter
	kalman_filter_cmd = new RCS_CMD_CHANNEL(kalman_filterFormat, "kalman_filter_cmd", "k_fltr_modulesvr", "k_fltr_module.nml");
	if(NULL == kalman_filter_cmd)
		return -1;
	if(!kalman_filter_cmd->valid())
		return -1;

	kalman_filter_stat = new RCS_STAT_CHANNEL(kalman_filterFormat, "kalman_filter_sts", "k_fltr_modulesvr", "k_fltr_module.nml");
	if(NULL == kalman_filter_stat)
		return -1;
	if(!kalman_filter_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "k_fltr_modulesvr", "k_fltr_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// kalman_filter
	if(NULL != kalman_filter_cmd)
	{
		delete kalman_filter_cmd;
		kalman_filter_cmd = NULL;
	}

	if(NULL != kalman_filter_stat)
	{
		delete kalman_filter_stat;
		kalman_filter_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int k_fltr_modulesvr_run();

int k_fltr_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

